UNIT mTObjekt;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses graphics;

type
   TObjekt = CLASS

     // weitere Attribute
     protected
         kenntCanvas : TCanvas;

     // weitere Methoden
     protected
        procedure zeichneBody (pStartXPosition: Real; pStartYPosition: Real; pZielXPosition: Real; pZielYPosition: Real); virtual; abstract;
     public
        constructor init (pCanvas: TCanvas); virtual;
        procedure zeichneDich (pStartXPosition: Real; pStartYPosition: Real; pZielXPosition: Real; pZielYPosition: Real); virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TObjekt: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TObjekt.init (pCanvas: TCanvas);
begin
  kenntCanvas := pCanvas;
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TObjekt.zeichneDich (pStartXPosition: Real; pStartYPosition: Real; pZielXPosition: Real; pZielYPosition: Real);
begin
  zeichneBody(pStartXPosition, pStartYPosition, pZielXPosition, pZielYPosition);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TObjekt.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
