UNIT mTScannerAutomat;

interface

uses mthilfstypen;

type
  TZustand = (zStart);

type
   TScannerAutomat = CLASS

     private
        aktuellerZustand : TZustand;
        startZustand : TZustand;
        function AusgabeFunktionG (pAktuellerZustand: TZustand; pEingabe: String) : TToken;
        function UebergangsFunktionF (pAktuellerZustand: TZustand; pEingabe: String) : TZustand;
     public
        constructor init;
        procedure setzeZurueck;
        function verarbeiteEingabe (pEingabe: String) : TToken;
        destructor gibFrei;

   end;

implementation


constructor TScannerAutomat.init;
begin
  startZustand := zStart;
  setzeZurueck;
end;

function TScannerAutomat.UebergangsFunktionF (pAktuellerZustand: TZustand; pEingabe: String) : TZustand;
begin
  result := zStart;
end;

function TScannerAutomat.AusgabeFunktionG (pAktuellerZustand: TZustand; pEingabe: String) : TToken;
begin
  result[1] := '';
  result[2] := '';  

  case pAktuellerZustand of
    zStart : begin
      if pEingabe = 'vor' then
      begin
        result[1] := 'befehl';
        result[2] := 'vor';
      end
      else if pEingabe = 'drehe_links' then
      begin
        result[1] := 'befehl';
        result[2] := 'drehe_links';
      end
      else if pEingabe = 'drehe_rechts' then
      begin
        result[1] := 'befehl';
        result[2] := 'drehe_rechts';
      end
      else if pEingabe = 'nimm' then
      begin
        result[1] := 'befehl';
        result[2] := 'nimm';
      end
      else if pEingabe = 'gib' then
      begin
        result[1] := 'befehl';
        result[2] := 'gib';
      end
      else if pEingabe = 'vornefrei' then
      begin
        result[1] := 'anfrage';
        result[2] := 'vornefrei';
      end
      else if pEingabe = 'itemda' then
      begin
        result[1] := 'anfrage';
        result[2] := 'itemda';
      end
      else if pEingabe = 'blicktnach_unten' then
      begin
        result[1] := 'anfrage';
        result[2] := 'blicktnach_unten';
      end
      else if pEingabe = 'blicktnach_oben' then
      begin
        result[1] := 'anfrage';
        result[2] := 'blicktnach_oben';
      end
      else if pEingabe = 'blicktnach_rechts' then
      begin
        result[1] := 'anfrage';
        result[2] := 'blicktnach_rechts';
      end
      else if pEingabe = 'blicktnach_links' then
      begin
        result[1] := 'anfrage';
        result[2] := 'blicktnach_links';
      end
      else if pEingabe = 'itemsimrucksack' then
      begin
        result[1] := 'anfrage';
        result[2] := 'itemsimrucksack';
      end                            
      else if pEingabe = 'wenn' then
      begin
        result[1] := 'kontroll';
        result[2] := 'wenn';
      end
      else if pEingabe = 'dann' then
      begin
        result[1] := 'kontroll';
        result[2] := 'dann';
      end
      else if pEingabe = 'sonst' then
      begin
        result[1] := 'kontroll';
        result[2] := 'sonst';
      end
      else if pEingabe = 'solangewie' then
      begin
        result[1] := 'kontroll';
        result[2] := 'solangewie';
      end
      else if pEingabe = 'tue' then
      begin
        result[1] := 'kontroll';
        result[2] := 'tue';
      end
      else if pEingabe = #123 then
      begin
        result[1] := 'kontroll';
        result[2] := #123;
      end
      else if pEingabe = #125 then
      begin
        result[1] := 'kontroll';
        result[2] := #125;
      end
      else if pEingabe = 'not' then
      begin
        result[1] := 'kontroll';
        result[2] := 'not';
      end

    end; //of pAktuellerZustand : zStart


  end;
end;

procedure TScannerAutomat.setzeZurueck;
begin
  aktuellerZustand := startZustand;
end;

function TScannerAutomat.verarbeiteEingabe (pEingabe: String) : TToken;
begin
  result := AusgabeFunktionG(aktuellerZustand,pEingabe);
  aktuellerZustand := UebergangsFunktionF(aktuellerZustand,pEingabe);
end;

destructor TScannerAutomat.gibFrei;
begin
end;


end.
