UNIT mTParser;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mtHilfsTypen, mtparserautomat, dialogs, Sysutils;

type
   TParser = CLASS

     // weitere Attribute
     private
        hatParserAutomat : TParserAutomat;

     // weitere Methoden
     public
        constructor init; virtual;
        function parseTokenliste (pTokenListe: TTokenListe) : Boolean; virtual;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TParser: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TParser.init;
begin
  hatParserAutomat := TParserAutomat.init;
end;


//-------- parseTokenliste (public) ------------------------------------
function TParser.parseTokenliste (pTokenListe: TTokenListe) : Boolean;
var
  position : Integer;
  letzteAusgabe : String;
begin

  position := 0;
  hatParserAutomat.setzeZurueck;

  while (position < length(pTokenListe)) and (not hatParserAutomat.istInFehlerZustand) do
  begin
    letzteAusgabe := hatParserAutomat.verarbeiteEingabe(pTokenListe[position]);
    position := position + 1;
  end;

  if hatParserAutomat.istInFehlerZustand
    then MessageDlg('Fehler beim Parsen des Tokens Nr: ' + IntToStr(position) + ' (' + pTokenListe[position - 1][2] + ') Fehlermeldung: ' + #13#10 + letzteAusgabe, mtError,[mbOk], 0);


  result := hatParserAutomat.istInAkzeptiertemZustand;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TParser.gibFrei;
begin
  //Hier Code einfgen.
end;

end.
